package cn.com.infosec.asn1.x509;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import java.util.Enumeration;
import java.util.Vector;

public class SubjectDirectoryAttributes extends ASN1Encodable {
   private Vector attributes;

   public static SubjectDirectoryAttributes getInstance(Object obj) {
      if (obj != null && !(obj instanceof SubjectDirectoryAttributes)) {
         if (obj instanceof ASN1Sequence) {
            return new SubjectDirectoryAttributes((ASN1Sequence)obj);
         } else {
            throw new IllegalArgumentException("illegal object in getInstance: " + obj.getClass().getName());
         }
      } else {
         return (SubjectDirectoryAttributes)obj;
      }
   }

   public SubjectDirectoryAttributes(ASN1Sequence seq) {
      ASN1Sequence var10000 = seq;
      super();
      Vector seq1;
      seq1 = new Vector.<init>();
      this.attributes = seq1;
      Enumeration seq2 = var10000.getObjects();

      while(seq2.hasMoreElements()) {
         ASN1Sequence var2 = ASN1Sequence.getInstance(seq2.nextElement());
         this.attributes.addElement(new Attribute(var2));
      }

   }

   public SubjectDirectoryAttributes(Vector attributes) {
      Vector var10000 = attributes;
      super();
      attributes = new Vector.<init>();
      this.attributes = attributes;
      Enumeration attributes1 = var10000.elements();

      while(attributes1.hasMoreElements()) {
         this.attributes.addElement(attributes1.nextElement());
      }

   }

   public DERObject toASN1Object() {
      SubjectDirectoryAttributes var10000 = this;
      ASN1EncodableVector var2;
      var2 = new ASN1EncodableVector.<init>();
      Enumeration var1 = var10000.attributes.elements();

      while(var1.hasMoreElements()) {
         var2.add((Attribute)var1.nextElement());
      }

      return new DERSequence(var2);
   }

   public Vector getAttributes() {
      return this.attributes;
   }
}
